package cn.citycraft.CityBuild;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import cn.citycraft.CityBuild.listen.Build;
import cn.citycraft.PluginHelper.config.FileConfig;
import cn.citycraft.PluginHelper.utils.VersionChecker;

public class CityBuild extends JavaPlugin implements CommandExecutor {
	public FileConfig config;
	public FileConfig data;
	public Map<Location, String> mhl;
	public String pluginname;
	public String servername;
	public boolean tipplayer;

	public String getfullmsg(final String path) {
		return servername + pluginname + " " + getmessage(path);
	}

	public String getmessage(final String path) {
		return config.getMessage(path);
	}

	@Override
	public boolean onCommand(final CommandSender sender, final Command cmd, final String string, final String[] args) {
		if (args.length == 1) {
			switch (args[0]) {
			case "reload":
				data.save();
				onLoad();
				sender.sendMessage(getfullmsg("Message.Reload"));
				return true;
			case "look":
				sender.sendMessage(getfullmsg("Message.Look"));
				if (mhl.isEmpty()) {
					sender.sendMessage(getfullmsg("Message.NotHave"));
				} else {
					for (final Entry<Location, String> info : mhl.entrySet()) {
						final String name = info.getValue();
						final Location loc = info.getKey();
						final World w = loc.getWorld();
						final int x = loc.getBlockX();
						final int z = loc.getBlockZ();
						sender.sendMessage(getfullmsg("Message.Info").replaceAll("%player%", name).replaceAll("%world%", w.getName()).replaceAll("%x%", x + "").replaceAll("%z%", z + ""));
					}
				}
				return true;
			case "clear":
				mhl.clear();
				data.set("MaxHeightList", null);
				data.save();
				sender.sendMessage(getfullmsg("Message.NotHave"));
				return true;
			case "put":
				final Player p = (Player) sender;
				mhl.put(p.getLocation(), p.getName());
				data.set("MaxHeightList", mhl);
				data.save();
			}
		}
		return false;
	}

	@Override
	public void onDisable() {
		data.set("MaxHeightList", mhl);
		data.save();
		getLogger().info(pluginname + "城市世界建筑保护已卸载!");
	}

	@Override
	public void onEnable() {
		Bukkit.getPluginManager().registerEvents(new Build(this), this);
		getLogger().info(pluginname + "城市世界建筑保护已加载!");
		new VersionChecker(this);
	}

	@SuppressWarnings("unchecked")
	@Override
	public void onLoad() {
		config = new FileConfig(this);
		data = new FileConfig("data.yml");
		mhl = (Map<Location, String>) config.get("MaxHeightList");
		if (mhl == null) {
			mhl = new HashMap<>();
		}
		servername = getmessage("servername");
		pluginname = getmessage("pluginname");
		tipplayer = config.getBoolean("tipplayer");
	}
}
