package cn.citycraft.CityBuild.listen;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.player.PlayerInteractEvent;

import com.bekvon.bukkit.residence.Residence;
import com.bekvon.bukkit.residence.protection.ClaimedResidence;

import cn.citycraft.CityBuild.CityBuild;

public class Build implements Listener {

	CityBuild plugin;

	public Build(final CityBuild main) {
		plugin = main;
	}

	// PlayerInteractEvent.class

	@EventHandler(ignoreCancelled = true)
	public void blockBreak(final BlockBreakEvent event) {
		event.setCancelled(CancelEvent(event.getPlayer(), event.getBlock(), false));
	}

	@EventHandler(ignoreCancelled = true)
	public void blockplace(final BlockPlaceEvent event) {
		event.setCancelled(CancelEvent(event.getPlayer(), event.getBlock(), true));
	}

	public boolean CancelEvent(final Player p, final Block b, final boolean place) {
		final Location loc = b.getLocation();
		final ClaimedResidence res = Residence.getResidenceManager().getByLoc(loc);
		if (res == null && !p.hasPermission("cb.build")) {
			final String blockname = b.getType().name();
			final World blockw = b.getWorld();
			final int blockx = b.getX();
			final int blocky = b.getY();
			final int blockz = b.getZ();
			for (final String protectworld : plugin.config.getStringList("ProtectWorld")) {
				if (protectworld.equalsIgnoreCase(blockw.getName())) {
					for (final String allowblock : plugin.config.getStringList("AllowList")) {
						if (blockname.equalsIgnoreCase(allowblock)) {
							for (final String noticeblock : plugin.config.getStringList("NoticeList")) {
								if (blockname.equalsIgnoreCase(noticeblock) && place) {
									if (plugin.tipplayer) {
										p.getPlayer().sendMessage(plugin.getfullmsg("Message.Tip"));
									}
									return false;
								}
							}
							final int maxheight = plugin.config.getInt("MaxHeight");
							if (blocky > maxheight && blockname.equalsIgnoreCase("Dirt")) {
								if (plugin.tipplayer) {
									p.getPlayer().sendMessage(plugin.getfullmsg("Message.Max").replaceAll("%maxheight%", maxheight + ""));
								}
								Bukkit.broadcast(plugin.getfullmsg("Message.Notice1").replaceAll("%player%", p.getDisplayName()).replaceAll("%maxheight%", maxheight + ""), "cb.notice");
								Bukkit.broadcast(plugin.getfullmsg("Message.Notice2").replaceAll("%world%", blockw.getName()).replaceAll("%x%", blockx + "").replaceAll("%z%", blockz + ""),
										"cb.notice");
								plugin.mhl.put(loc, p.getName());
								return true;
							}
							return false;
						}
					}
					final String[] message = { plugin.getfullmsg("Message.Wran"), plugin.getfullmsg("Message.Allow"), plugin.getfullmsg("Message.Relieve") };
					if (plugin.tipplayer) {
						p.getPlayer().sendMessage(message);
					}
					return true;
				}
			}
		}
		return false;
	}

	public boolean CancelEvent(final Player p, final Material m) {
		final ClaimedResidence res = Residence.getResidenceManager().getByLoc(p.getLocation());
		if (res == null && !p.hasPermission("cb.build")) {
			final String blockname = m.name();
			for (final String protectworld : plugin.config.getStringList("ProtectWorld")) {
				if (protectworld.equalsIgnoreCase(p.getWorld().getName())) {
					for (final String notallowblock : plugin.config.getStringList("NotAllowList")) {
						if (blockname.equalsIgnoreCase(notallowblock)) {
							if (plugin.tipplayer) {
								p.getPlayer().sendMessage(plugin.getfullmsg("Message.NotAllow"));
							}
							return true;
						}
					}
				}
			}
		}
		return false;
	}

	@EventHandler(ignoreCancelled = true)
	public void playerInteract(final PlayerInteractEvent event) {
		event.setCancelled(CancelEvent(event.getPlayer(), event.getMaterial()));
	}
}
